#!/bin/sh

# add fwmark entries to classify different types of traffic - Set fwmark from 20-26 according to
#                                                             desired class. 20 is highest prio.
iptables -t mangle -A qosout -p tcp --sport 0:1024 -j MARK --set-mark 23 # Default for low port traffic 
iptables -t mangle -A qosout -p tcp --dport 0:1024 -j MARK --set-mark 23 # "" 
iptables -t mangle -A qosout -p tcp --dport 20 -j MARK --set-mark 25     # ftp-data port, low prio
iptables -t mangle -A qosout -p tcp --dport 5190 -j MARK --set-mark 23   # aol instant messenger
iptables -t mangle -A qosout -p icmp -j MARK --set-mark 20               # ICMP (ping) - high prio, impress friends
iptables -t mangle -A qosout -p udp --dport 123 -j MARK --set-mark 20    # NTP should be low-lag
iptables -t mangle -A qosout -p udp --dport 53 -j MARK --set-mark 21     # DNS name resolution (small packets)
iptables -t mangle -A qosout -p tcp --dport 22 -j MARK --set-mark 22    # secure shell
iptables -t mangle -A qosout -p tcp --sport 22 -j MARK --set-mark 22    # secure shell
iptables -t mangle -A qosout -p tcp --dport 22022 -j MARK --set-mark 22 # ssh on non-default port
iptables -t mangle -A qosout -p tcp --sport 22022 -j MARK --set-mark 22 # sshd on non-default port
iptables -t mangle -A qosout -p tcp --dport 2401 -j MARK --set-mark 24 # CVS pserver
# iptables -t mangle -A qosout -p ipv6-crypt -j MARK --set-mark 24         # IPSec - we dont know what the payload is though...
iptables -t mangle -A qosout -p tcp --sport 80 -j MARK --set-mark 25   # Local web server
iptables -t mangle -A qosout -p tcp -m length --length :80 -j MARK --set-mark 21 # small packets (probably just ACKs)
iptables -t mangle -A qosout -p tcp --sport 3389 -j MARK --set-mark 23   # windows remote computer connection
iptables -t mangle -A qosout -m mark --mark 0 -j MARK --set-mark 26      # redundant- mark any unmarked packets as 26 (low pri

