run_command ()
{
    $1 > /tmp/dslqos.$$ 2>&1
    if [ $? -ne 0 -a "$2" ]
    then
	log_error "$2"
	log_error "$1"
	log_error `cat /tmp/dslqos.$$`
	case "$SYSLOG" in 
	    yes)
		{
		    echo "$2"
		    echo "$1"
		    cat /tmp/dslqos.$$ 
		} | logger -t DSLQOS 
		;;
	esac
    fi
}


setup_filters ()
{

$IT -N qosout -t mangle
eval i='$DSLQOS_INTERNET_DEV'
$IT -A POSTROUTING -t mangle -o $i -j qosout

/etc/dslqos/ipt_rules.sh

}


setup_qos () 
{
    do_insmod cls_fw
    # do_insmod imq
    do_insmod ip_queue
    # ifconfig imq0 up
    if [ $DSLQOS_QUEUELENGTH.t = .t ]
    then
      DSLQOS_QUEUELENGTH=50
    fi

}

IT=/sbin/iptables
DSLQOS_CONFIG_DIR='/var/run'
. "$DSLQOS_CONFIG_DIR"/dslqos.conf

if [ -f /var/run/ip_net.conf ]
then
    . /var/run/ip_net.conf
fi


if [ -f /usr/bin/logger ]
then
    SYSLOG='yes'
else
    SYSLOG='no'
fi

# Look for dsl_qos_queue process
psaux=$(ps aux)

if [ $(echo "$psaux" |grep -c dsl_qos_queue) -gt 0 ]
then
  status="1"
fi
  

case "$1" in
    start)
	colecho 'Starting Quality of Service (DSL_QOS)...' gn
        if [ "$status" = '1' ]
	then
	    log_error 'Error! QoS still running'
	    exit 1
	fi
        	. /etc/boot.d/base-helper
        setup_qos 
        setup_filters
        /usr/local/sbin/dsl_qos_queue -d -i $DSLQOS_INTERNET_DEV -t $DSLQOS_INTERNET_TYPE -r $DSLQOS_UPLOAD_RATE -m $DSLQOS_PRIO_FIRST -n $DSLQOS_PRIO_N -l $DSLQOS_QUEUELENGTH
  ;;
  stop)
    if [ "$status" = '1' ]
    then  
      
      colecho 'Stopping Quality of Service ...' gn
      killall dsl_qos_queue
      #for idx in `seq $DSLQOS_INTERNET_DEV_N`
      #do
      #    eval i='$DSLQOS_INTERNET_DEV_'$idx
      eval i='$DSLQOS_INTERNET_DEV'
     #     $IT -D FORWARD  -t mangle -i $i -j qosin
     #     $IT -D FORWARD  -t mangle -i $i -j IMQ --todev 0
          $IT -D POSTROUTING -t mangle -o $i -j qosout
       #   $IT -D POSTROUTING -t mangle -o $i -j IMQ --todev 0
      #done

      $IT -F qosout -t mangle
      $IT -X qosout -t mangle
      
      
      rmmod cls_fw
      rmmod ip_queue
      colecho '... finished' gn
    else
      colecho 'Error! DSLQoS not running' br x br
    fi
    
    ;;
  restart)

    colecho 'Restarting Quality of Service ...' gn
    $0 stop
    $0 start
    ;;

  status)

    if [ "$status" = "1" ]
    then
      colecho 'DSLQoS is running' gn
    else
      colecho 'DSLQoS is not running' gn
    fi
    ;;
esac